﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Chart_WPF_Sample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        SfChart chart;
        private viewmodel view;
        public MainWindow()
        {
            InitializeComponent();
           
        }

        public ChartSeriesCollection chartSeries
        {
            get;
            set;

        }

        public ChartSeriesCollection clonedSeries 
        { 
            get; 
            set; 
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            chart = new SfChart();
            chart.Margin = new Thickness(5, 5, 5, 5);
            chart.PrimaryAxis = new CategoryAxis();
            chart.SecondaryAxis = new NumericalAxis();
            view = new viewmodel();
            grid.Children.Add(chart);
            //Adding Series
            chartSeries = new ChartSeriesCollection();
            ColumnSeries series = new ColumnSeries();
            series.ItemsSource = view.SneakersDetail;
            series.XBindingPath = "Brand";
            series.YBindingPath = "No_Of_Items";
            chartSeries.Add(series);

            ColumnSeries series2 = new ColumnSeries();
            series2.ItemsSource = view.SneakersDetail;
            series2.XBindingPath = "Brand";
            series2.YBindingPath = "Price";
            chartSeries.Add(series2);

            ColumnSeries series3 = new ColumnSeries();
            series3.ItemsSource = view.SneakersDetail;
            series3.XBindingPath = "Brand";
            series3.YBindingPath = "Count";
            chartSeries.Add(series3);

            chart.Series = chartSeries;

        }

        private ChartSeries CloneSeries(DependencyObject obj)
        {
            ColumnSeries column = new ColumnSeries();
            ChartSeriesBase series = obj as ChartSeriesBase;
            if (series is CartesianSeries)
                (series as CartesianSeries).IsTransposed = (series as CartesianSeries).IsTransposed;
            column.Palette = series.Palette;
            column.TrackBallLabelTemplate = series.TrackBallLabelTemplate;
            column.VisibilityOnLegend = series.VisibilityOnLegend;
            column.ColorModel = series.ColorModel;
            column.ItemsSource = series.ItemsSource;
            column.XBindingPath = series.XBindingPath;
            column.YBindingPath = (series as ColumnSeries).YBindingPath;
            column.ShowEmptyPoints = series.ShowEmptyPoints;
            column.LegendIconTemplate = series.LegendIconTemplate;
            column.LegendIcon = series.LegendIcon;
            column.Label = series.Label;
            column.Interior = series.Interior;
            column.EmptyPointValue = series.EmptyPointValue;
            column.EmptyPointSymbolTemplate = series.EmptyPointSymbolTemplate;
            column.EmptyPointStyle = series.EmptyPointStyle;
            column.EmptyPointInterior = series.EmptyPointInterior;
            return column;
        }

        private void preview_Click(object sender, RoutedEventArgs e)
        {
            chartSeries = new ChartSeriesCollection();
            Window window = new Window();
            Grid grid = new Grid();
            foreach (var item in chart.Series)
            {
                chartSeries.Add(CloneSeries(item));
            }
            SfChart previewChart = new SfChart();
            previewChart.Margin = new Thickness(0, 5, 2, 0);
            previewChart.Series = chartSeries;
            previewChart.Height = 300d;
            grid.Children.Add(previewChart);
            window.Content = grid;
            window.WindowState = WindowState.Maximized;
            window.Show();
        }
    }
    public class model
    {
        public double No_Of_Items { get; set; }

        public string Brand { get; set; }

        public double Price { get; set; }

        public int Count { get; set; }

    }
    public class viewmodel
    {
        public viewmodel()
        {
            this.SneakersDetail = new ObservableCollection<model>();

            SneakersDetail.Add(new model() { Count=100, Price=120, Brand = "Adidas", No_Of_Items = 252 });
            SneakersDetail.Add(new model() { Count=160, Price=150, Brand = "Nike", No_Of_Items = 172 });
            SneakersDetail.Add(new model() { Count=130, Price=180, Brand = "Reebok", No_Of_Items = 302 });
            SneakersDetail.Add(new model() { Count=190, Price=130, Brand = "Fila", No_Of_Items = 181 });
            SneakersDetail.Add(new model() { Count=180, Price=160, Brand = "Puma", No_Of_Items = 100 });
        }

        public ObservableCollection<model> SneakersDetail { get; set; }
    }
}
